; Assembly Source File
; Created 26/06/03, 18:40:43
; getkey from Seawar 2.0

 even
 	include "compat.h"
 	
	xdef getkey
;	xdef wait_a_key
;	xdef wait_no_key
	xdef Sprite16x16x4_or

key_test MACRO
	btst.b	#\2,\1(a1)
	bne.s	\@0
	bset.b	#\3,d0
\@0
	ENDM
	
	section ".data"
	include "sprites.h"
		
;getkey
;	input: nothing (but buffers in datas)
;	output: d0.l
;	destroy: d0-d2/a0-a1
;	gets keys... returns d0
;	
;	|	key (92/89)	|	d0.w	|
;	+-----------------------+---------------+
;	|	none		|	0	|									
;	|	up		|	+1	|									
;	|	down		|	+2	|									
;	|	right		|	+4	|
;	|	left		|	+8	|
;	|	esc		|	+16	|
;	|	enter/2nd	|	+32	|									
;	|	hand		|	+32	|
;
	
; wait_a_key:

;	bsr.s	getkey
;	tst.w	d0			; wait until d0 > 0
;	beq.s	wait_a_key
	
; wait_no_key:

;	bsr.s	getkey
;	tst.w	d0			; wait until d0 = 0
;	bne.s	wait_no_key
;	rts
	
getkey:
	move.w	d0,-(a7)

 ScanKbd:				; keyScan par ExtendeD (modified)

	moveq.l	#9,d0
	lea.l	KbdMat(pc),a0
	move.w	#%1111111111111110,d2

 SaveRow:

	move.w	d2,$600018
	moveq	#11,d1			; d1=0

 WaitKeys:

	dbra.s	d1,WaitKeys		; copy the ports to a virtual keybord table
	move.b	$60001B,(a0)+
	rol.w	#1,d2
	dbra.s	d0,SaveRow	

	lea.l	KbdMat(pc),a1		; dixit: "clair, facile  utiliser, efficace, rapide"

	moveq.l	#0,d0
	tst.w	(a7)
	beq.s	enter_test_89	

 enter_test_92:
	key_test 0,3,5			; affect to each key its number
	key_test 6,6,5
	key_test 9,1,5
	
 up_test_92:
 	key_test 0,5,0

 down_test_92:
 	key_test 0,7,1

 right_test_92:
	key_test 0,6,2
	
 left_test_92:
	key_test 0,4,3
 	
 esc_test_92:
	key_test 8,6,4

	bra.s	getkey_end

 enter_test_89:
	key_test 1,0,5
	key_test 0,4,5
	
 up_test_89:
 	key_test 0,0,0

 down_test_89:
 	key_test 0,2,1

 right_test_89:
	key_test 0,3,2
	
 left_test_89:
	key_test 0,1,3
 	
 esc_test_89:
	key_test 6,0,4

 getkey_end:
 
 	addq.l	#2,a7
 	rts


KbdMat:		ds.b 	10 

Sprite16x16x4_or:
; void Sprite16x16x4_or(register short x asm("%d0"),register short y asm("%d1"),register short nbr asm("%d2"),register void *dest0 asm("%a0"),register void *dest1 asm("%a1"));

	move.l	a2,-(a7)

	lsl.w	#6,d2
	lea.l	spr_list(pc),a2
	adda.w	d2,a2

	move.w	d1,d2
	lsl.w	#4,d1
	sub.w	d2,d1

	move.w	d0,d2
	lsr.w	#4,d2

	add.w	d2,d1
	add.w	d1,d1
	adda.w	d1,a0
	adda.w	d1,a1

	moveq.l	#16-1,d2
	
	and.w	d2,d0
	moveq.l	#16,d1
	sub.w	d0,d1

 loop:

	moveq.l	#0,d0
	move.w	(a2)+,d0
	lsl.l	d1,d0
	or.l	d0,(a0)

	moveq.l	#0,d0
	move.w	30(a2),d0
	lsl.l	d1,d0
	or.l	d0,(a1)
    
	lea.l	30(a0),a0
	lea.l	30(a1),a1

	dbra.s	d2,loop

	move.l	(a7)+,a2

	rts
 